/**
 * Copyright (c) 2013-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.jmx.api.api.monitoring;


/**
 * <p>
 * Metrics associated to an object pool.
 * </p>
 * 
 * @author Christophe DENEUX - Linagora
 * 
 */
public interface ObjectPoolMetrics {

    /**
     * Get the current min idle size of the object pool
     */
    public Long getMinIdleSize();

    /**
     * Get the max size of the object pool
     */
    public Long getMaxSize();

    /**
     * Get the current number of borrowed objects of the object pool
     */
    public Long getBorrowedObjectNumber();

    /**
     * Get the max number of borrowed objects of the object pool
     */
    public Long getBorrowedObjectMaxNumber();

    /**
     * Get the current number of idle objects of the object pool
     */
    public Long getIdleObjectNumber();

    /**
     * Get the max number of idle objects of the object pool
     */
    public Long getIdleObjectMaxNumber();

    /**
     * Get the current number of exhaustions of the thread pool
     */
    public Long getExhaustions();

}
