/**
 * Copyright (c) 2013-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.jmx.api.api.monitoring;


/**
 * <p>
 * Metrics associated to a thread pool.
 * </p>
 * 
 * @author Christophe DENEUX - Linagora
 * 
 */
public interface ThreadPoolMetrics {

    /**
     * Get the current min size of the thread pool
     */
    public Long getMinSize();

    /**
     * Get the max size of the thread pool
     */
    public Long getMaxSize();

    /**
     * Get the current number of allocated threads of the thread pool
     */
    public Long getAllocatedThreadsSize();

    /**
     * Get the max number of allocated threads of the thread pool
     */
    public Long getAllocatedThreadsMaxSize();

    /**
     * Get the current number of idle threads of the thread pool
     */
    public Long getIdleThreadsSize();

    /**
     * Get the max number of allocated threads of the thread pool
     */
    public Long getIdleThreadsMaxSize();

    /**
     * Get the current number of enqueued requests in the thread pool
     */
    public Long getEnqueuedRequestsSize();

    /**
     * Get the max number of enqueued requests in the thread pool
     */
    public Long getEnqueuedRequestsMaxSize();

}
